package contrib.tapestry.exception;

import java.io.Serializable;

import org.apache.tapestry.ILocation;

public class ExceptionProperty implements Serializable {

   private String name;
   private Object value;
   private ILocation location = null;

   public ExceptionProperty(String name, Object value) {
      this.name = name;
      this.value = value;
      if (value instanceof ILocation) {
         this.location = (ILocation) value;
      }
   }

   public String getName() {
      return this.name;
   }

   public String getValue() {
      return this.value.toString();
   }

   public ILocation getLocation() {
      return this.location;
   }

   public boolean isSourceAvailable() {
      return (this.location != null);
   }

}