package contrib.tapestry.exception.components;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.bean.EvenOdd;

import contrib.tapestry.exception.ExceptionDescription;

public class ExceptionDisplay extends BaseComponent {
   private IBinding _exceptionsBinding;
   private ExceptionDescription _exception;
   private int _count;
   private int _index;
   private EvenOdd _evenOdd;

   public void setExceptionsBinding(IBinding value) {
      this._exceptionsBinding = value;
   }

   public IBinding getExceptionsBinding() {
      return this._exceptionsBinding;
   }

   /**
    *  Each time the current exception is set, as a side effect,
    *  the evenOdd helper bean is reset to even.
    */
   public void setException(ExceptionDescription value) {
      this._exception = value;
      this._evenOdd.setEven(true);
   }

   public ExceptionDescription getException() {
      return this._exception;
   }

   protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle) {
      ExceptionDescription[] exceptions = (ExceptionDescription[]) _exceptionsBinding.getObject("exceptions", ExceptionDescription[].class);
      this._count = exceptions.length;
      try {
         this._evenOdd = (EvenOdd) getBeans().getBean("evenOdd");
         super.renderComponent(writer, cycle);
      } finally {
         this._exception = null;
         this._evenOdd = null;
      }
   }

   public void setIndex(int value) {
      this._index = value;
   }

   public boolean isLast() {
      return this._index == (this._count - 1);
   }
 
}